#ifndef DFS_ONLINE_CYCLE_DETECTOR_HPP
#define DFS_ONLINE_CYCLE_DETECTOR_HPP

#include <vector>
#include "bidirectional_adjacency_list.hpp"
#include "filter_graph.hpp"
#include "pcs.hpp"

class DFS_online_cycle_detector {
  typedef bidirectional_adjacency_list<vector_set<unsigned int> > graph2_t;
  typedef filter_graph<graph2_t,zero_edge_select> graph1_t;
public:  
  typedef std::vector<unsigned int>::const_reverse_iterator iterator;

  graph1_t _graph;
  std::vector<variable_info> &_varmap;
  std::vector<bool> _data;
  std::vector<unsigned int> _vindex;  // visitation index
  std::vector<unsigned int> _stack; 
  unsigned int _index;
  bool _invalid;
  std::vector<unsigned int> _n2i;
  std::vector<unsigned int> _i2c;  
public:
  DFS_online_cycle_detector(graph2_t &g, std::vector<variable_info> &);

  void finish(std::vector<unsigned int> &);

  void new_edge(unsigned int, unsigned int, 
		std::vector<unsigned int> &);

  iterator begin(void) const { return _i2c.rbegin(); }
  iterator end(void) const { return _i2c.rend(); }
private:
  void cycle_detect(unsigned int, 
		    std::vector<unsigned int> &);
};

#endif
