#ifndef POSCC1_ONLINE_CYCLE_DETECTOR_HPP
#define POSCC1_ONLINE_CYCLE_DETECTOR_HPP

#include <vector>
#include "pcs.hpp" // for zero_edge_select
#include "bidirectional_adjacency_list.hpp"
#include "filter_graph.hpp"

class POSCC1_online_cycle_detector {
  typedef bidirectional_adjacency_list<vector_set<unsigned int> > graph2_t;
  typedef filter_graph<graph2_t,zero_edge_select> graph1_t;
public:  
  graph1_t _graph; // the filtered graph
  std::vector<variable_info> &_varmap;

  std::vector<unsigned int> _c2i; 
  std::vector<unsigned int> _data;
public:
  POSCC1_online_cycle_detector(graph2_t &, std::vector<variable_info> &);

  void new_edge(unsigned int, unsigned int, std::vector<unsigned int> &);
  void finish(std::vector<unsigned int> &) {} // don't need to do anything here
private:
  void dfs_b(unsigned int, unsigned int, std::vector<unsigned int> &);
  void dfs_f(unsigned int, unsigned int, std::vector<unsigned int> &);
  void reassign(unsigned int,
		std::vector<unsigned int> &, 
		std::vector<unsigned int> &, 
		std::vector<unsigned int> &);
};

#endif



