#ifndef DOMAIN_SET_ADAPTOR_HPP
#define DOMAIN_SET_ADAPTOR_HPP

#include "bitset.hpp"
#include "vector_set.hpp"

template<class T>
class domain_set_adaptor : public T {
public:
  domain_set_adaptor(unsigned int) {
  }

  domain_set_adaptor(domain_set_adaptor const &src)
    : T(src) {
  }
};

template<class T, class S>
bool set_union(domain_set_adaptor<T> &to, S const &from) {
  return set_union(static_cast<T&>(to), from);
}

template<class T, class S>
bool set_union(domain_set_adaptor<T> &to, domain_set_adaptor<S> const &from) {
  return set_union(static_cast<T&>(to), static_cast<S const &>(from));
}

#endif
