#ifndef FIFO_STRATEGY_HPP
#define FIFO_STRATEGY_HPP

#include <deque>
#include "vector_set.hpp"
#include "bidirectional_adjacency_list.hpp"

class fifo_strategy
{
 protected:
  std::deque<unsigned int> _queue;
 public:
  fifo_strategy(bidirectional_adjacency_list<vector_set<unsigned int> > const &);
  void push(unsigned int);
  unsigned int top(void) const;
  void pop(void);
  bool empty(void) const;
  void merge(unsigned int, unsigned int);
};

#endif


