// This class should not be viewed as anything other than
// a hack to get something to work.

#ifndef FILTER_GRAPH_HPP
#define FILTER_GRAPH_HPP

template<class G, class FilterFunc> 
class filter_graph {
private:
  // the iterator classes
  template<class T>
  class const_internal_iterator {
  private:
    FilterFunc _func;
    T _pos;
    T _last;
  public:
    const_internal_iterator(void) {
    }

    const_internal_iterator(T pos,
		    T last)
      : _pos(pos), _last(last) {
      // find first correct place.
      while(_pos != _last && !_func(*(_pos.base()->second()))) { ++_pos; }
    }
    
    inline unsigned int operator*(void) const {
      return *_pos;
    }

    inline bool operator==(const_internal_iterator const &src) const {
      return _pos == src._pos;
    }

    inline bool operator!=(const_internal_iterator const &src) const {
      return _pos != src._pos;
    }
    
    inline const_internal_iterator const &operator++(void) {     
      while(++_pos != _last && !_func(*(_pos.base()->second()))) { }
      return (*this);
    }

    inline const_internal_iterator operator++(int) {
      const_internal_iterator r(*this);
      ++(*this);
      return r;
    }
  };

public:
  typedef const_internal_iterator<typename G::const_siterator> const_siterator;
  typedef const_internal_iterator<typename G::const_piterator> const_piterator;

  // friends 
  typedef filter_graph<G,FilterFunc> self;
  friend unsigned int size<>(self const &);
  friend std::pair<const_siterator,const_siterator> successors<>(unsigned int, self const &);
  friend std::pair<const_piterator,const_piterator> predecessors<>(unsigned int, self const &);
  friend typename G::value_type &get<>(diedge const &e,self &);  
private:
  G const &_graph;
public:
  filter_graph(G const &g) 
    : _graph(g) {
  }
};

template<class G, class T>
unsigned int size(filter_graph<G,T> const &self) { return size(self._graph); }

template<class G, class T>
typename G::value_type &get(diedge const &e, filter_graph<G,T> &self) {
  return get(e,self._g);
}

template<class G, class T>
std::pair<typename filter_graph<G,T>::const_siterator,
	  typename filter_graph<G,T>::const_siterator> 
successors(unsigned int n, filter_graph<G,T> const &self) {
  typename G::const_siterator first,last;  

  boost::tie(first,last) = successors(n,self._graph);

  return std::make_pair(typename filter_graph<G,T>::const_siterator(first,last),
			typename filter_graph<G,T>::const_siterator(last,last));
}

template<class G, class T>
std::pair<typename filter_graph<G,T>::const_piterator,
	  typename filter_graph<G,T>::const_piterator> 
predecessors(unsigned int n, filter_graph<G,T> const &self) {
  typename G::const_piterator first,last;  

  boost::tie(first,last) = predecessors(n,self._graph);

  return std::make_pair(typename filter_graph<G,T>::const_piterator(first,last),
			typename filter_graph<G,T>::const_piterator(last,last));
}

template<class F, class G, class T>
void merge(unsigned int n, unsigned int w, 
	   filter_graph<G,T> const &self) {
  merge<F,G>(n,w,self._graph);
}

#endif
