#ifndef MNR_ONLINE_CYCLE_DETECTOR_HPP
#define MNR_ONLINE_CYCLE_DETECTOR_HPP

#include <vector>
#include "pcs.hpp" // for zero_edge_select
#include "bidirectional_adjacency_list.hpp"
#include "filter_graph.hpp"

class MNR_online_cycle_detector {
  typedef bidirectional_adjacency_list<vector_set<unsigned int> > graph2_t;
  typedef filter_graph<graph2_t,zero_edge_select> graph1_t;
public:  
  graph1_t _graph; // the filtered graph
  std::vector<variable_info> &_varmap;

  std::vector<unsigned int> _c2i; 
  std::vector<unsigned int> _i2c; 
  std::vector<unsigned int> _data;
public:
  MNR_online_cycle_detector(graph2_t &, std::vector<variable_info> &);

  void new_edge(unsigned int, unsigned int, std::vector<unsigned int> &);
  void finish(std::vector<unsigned int> &) {} // don't need to do anything here
private:
  void dfs_f(unsigned int, unsigned int);
  void reorder(unsigned int, unsigned int, std::vector<unsigned int> &);
};

#endif



