#ifndef PEARCE_SOLVERS_HPP
#define PEARCE_SOLVERS_HPP

#include <set>
#include <vector>

#include "bidirectional_adjacency_list.hpp"
#include "vector_set.hpp"
#include "bitset.hpp"
#include "store.hpp"

// basically this does what the new export keyword should do.
#define INST(x,y) store<vector_set<unsigned int> > *pearce_solvers_ ## x(unsigned int, \
				     bidirectional_adjacency_list<std::set<unsigned int> > &, \
				     std::vector<variable_info> &,\
                                     checker_stats &, \
				     bool);

INST(stdset,std::set<unsigned int>);
INST(vecset,vector_set<unsigned int>);
INST(bitset,bitset);

#undef INST

#endif
