#ifndef SIMPLE_CYCLE_DETECTOR_HPP
#define SIMPLE_CYCLE_DETECTOR_HPP

#include <vector>
#include "bidirectional_adjacency_list.hpp"
#include "cycle_detector.hpp"
#include "pcs.hpp"

class simple_cycle_detector : public cycle_detector {
  typedef bidirectional_adjacency_list<vector_set<unsigned int> > graph_t;
public:  
  graph_t &_graph;
  std::vector<variable_info> &_varmap;
  std::vector<bool> _data;
  std::vector<unsigned int> _vindex;  // visitation index
  std::vector<unsigned int> _stack; 
  unsigned int _index;
  std::vector<unsigned int> _vqueue;
public:
  simple_cycle_detector(graph_t &g, std::vector<variable_info> &);

  void finish(std::vector<unsigned int> &);

  void new_edge(unsigned int, unsigned int, 
		std::vector<unsigned int> &);
private:
  void cycle_detect(unsigned int, 
		    std::vector<unsigned int> &);
};

#endif
