#include "PKH_online_strongly_connected_components.hpp"

#define VISITED(x) self._data[(x<<1)]
#define IN_COMPONENT(x) self._data[(x<<1)+1]
#define C2I(x) self._c2i[x]
#define I2C(x) self._i2c[x]

void reassign(unsigned int t, std::vector<unsigned int> &reachable, std::vector<unsigned int> &reaching, 
	      std::vector<unsigned int> &scc, PKH_online_strongly_connected_components &self) {
  
  std::vector<unsigned int> tmp;
  scc.push_back(t);
  IN_COMPONENT(t)=false; // do this to ensure that
                         // the tail node is available
                         // to represent the new component.

  tmp.reserve(reachable.size() + reaching.size());  
  
  std::vector<unsigned int>::iterator iend(reaching.end());
  for(std::vector<unsigned int>::iterator i(reaching.begin());
      i!=iend;++i) {
    unsigned int n(I2C(*i));
    tmp.push_back(n);
    VISITED(n) = false;
  }

  iend = reachable.end();
  for(std::vector<unsigned int>::iterator i(reachable.begin());
      i!=iend;++i) {
    unsigned int n(I2C(*i));
    tmp.push_back(n);      
    if(IN_COMPONENT(n)) {
      scc.push_back(n);
      IN_COMPONENT(n) = false;
    }
    VISITED(n) = false;
  }
  
  std::vector<unsigned int>::iterator i(reachable.begin());
  std::vector<unsigned int>::iterator j(reaching.begin());
  std::vector<unsigned int>::iterator jend(reaching.end());

  unsigned int index(0);
  while(i != iend || j != jend) {
    unsigned int w;
    if(j == jend || (i != iend && *i < *j)) {
      w=*i;++i;
    } else {
      w=*j;++j;
    }
    unsigned int n(tmp[index++]);
    // allocate n at w
    I2C(w)=n;
    C2I(n)=w;
  }

  if(scc.size() == 1) { scc.clear(); }
}



















