#ifndef OTO1_STRATEGY_HPP
#define OTO1_STRATEGY_HPP

#include <set>
#include <vector>
#include <algorithm>
#include <sys/time.h>
#include <unistd.h>
#include "assert.h"
#include "bidirectional_adjacency_list.hpp"
#include "worklist_strategy.hpp"

class oto_comp {
private:
  std::vector<unsigned int> *_timestamps;
public:
  oto_comp(std::vector<unsigned int> &timestamps) 
    : _timestamps(&timestamps) {    
  }

  bool operator()(unsigned int a, unsigned int b) const {
    return (*_timestamps)[a] < (*_timestamps)[b];
  }
};

class oto1_strategy : public worklist_strategy {
protected:    
  std::vector<unsigned int> _n2i; // node-to-topological index map
  std::set<unsigned int, oto_comp> _marks;
  std::vector<bool> _visited;
public:
  oto1_strategy(bidirectional_adjacency_list<vector_set<unsigned int> > const &); 
  void graph_change(bidirectional_adjacency_list<vector_set<unsigned int> > const &);
  void push(unsigned int);
  void pop(void);
  bool is_marked(unsigned int ) const;
  unsigned int top(void) const;
  bool empty(void) const;
  void merge(unsigned int, unsigned int);
private:
  void visit(unsigned int, unsigned int &, bidirectional_adjacency_list<vector_set<unsigned int> > const &);
};

#endif





