#ifndef OTO_STRATEGY_HPP
#define OTO_STRATEGY_HPP

// This graph queue exists because of the work
// by Atsushi Kanamori and Daniel Weise which 
// suggest that it is a "robust" choice when
// no static information is known about the graph.

#include <set>
#include <vector>
#include <sys/time.h>
#include <unistd.h>
#include "assert.h"
#include "bidirectional_adjacency_list.hpp"
#include "worklist_strategy.hpp"

class oto_strategy : public worklist_strategy {
private:
  std::vector<unsigned int> _priorities;
  std::vector<unsigned int> _current;
  std::vector<unsigned int> _next;
public:
  oto_strategy(bidirectional_adjacency_list<vector_set<unsigned int> > const &);
  void graph_changed(bidirectional_adjacency_list<vector_set<unsigned int> > const &);
  void push(unsigned int);
  void pop(void);
  bool is_marked(unsigned int) const;
  unsigned int top(void) const;
  bool empty(void) const;
  void merge(unsigned int, unsigned int);
  bool operator()(unsigned int, unsigned int) const;
};

#endif








