%name pcs_scanner
%define MEMBERS public: int line_no,col_no;
%define LEX_PARAM YY_pcs_parser_STYPE *val
%header{
#include <cstdlib>
#include "pcs_parser.hpp"
%}

DIGIT [0-9]
ID  [a-zA-Z_/][a-zA-Z_/\-0-9]*

%%

{ID}    val->var = new std::string(yytext); col_no += val->var->size(); return pcs_parser::NAME;
{DIGIT}+ col_no += strlen(yytext); val->num = atoi(yytext); return pcs_parser::NUMBER;
[ \t]   col_no++; /* WHITESPACE */
"\n"    line_no++;col_no=0; /* WHITESPACE */
"&"     col_no++;return pcs_parser::AMPERSAND;
"*"     col_no++;return pcs_parser::DEREF;
"("     col_no++;return pcs_parser::LBRACE;
")"     col_no++;return pcs_parser::RBRACE;
"="     col_no++;return pcs_parser::SUPSET;
"+"     col_no++;return pcs_parser::PLUS;
";"     col_no++;return pcs_parser::SEMI_COLON;
":"     col_no++;return pcs_parser::COLON;
"#"     col_no++;return pcs_parser::HASH;

.       col_no++;return pcs_parser::UNKNOWN;
%%





