#ifndef WEIGHTED_DIEDGE_HPP
#define WEIGHTED_DIEDGE_HPP

class weighted_diedge {
 public:
  // there is no point making
  // these members private as there
  // no restrictions on their value

  typedef struct hash {
    size_t operator()(weighted_diedge const &a) const {
      // this is slightly dodgy as I know there
      // is a bias toward the weight being zero.
      return (a.tail ^ a.head) + a.weight;
    }
  } hash;

  unsigned int tail;
  unsigned int head;
  unsigned int weight;
 public:
  weighted_diedge(unsigned int t, unsigned int h, unsigned int w) 
    : tail(t), head(h), weight(w) {}
  
  bool operator==(weighted_diedge const &src) const {
    return tail == src.tail && head == src.head 
      && weight == src.weight;
  }
  
  bool operator<(weighted_diedge const &src) const {
    if(tail < src.tail) {
      return true;
    } else if(tail == src.tail) {
      if(head < src.head) {
	return true;
      } else if(head == src.head) {
	return weight < src.weight;
      }
      return false;
    } else {
      return false;
    }
  }
};


#endif
