/* the point about this test is that
 * a function pointer can point
 * to several functions at once. therefore,
 * effects must be merged together
 *
 * the solution should determine that c can point
 * to {NULL, /main/g:local, /main/h:local}
 */

void f(int **b) { *b = 0; }

void g(int **b) {
  int local;
  *b = &local;
}

void h(int **b) {
  int local; 
  *b = &local;
}

int main(int argc, char *argv) {
  int *c;
  void (*fptr)(int**) = &f;
  
  if(argc == 1) { fptr = &g; }
  else if(argc == 2) { fptr = &h; }

  fptr(&c);
 
  return 0;
}
